<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>JSword - Getting Involved</title>
</head>

<body>
<h1>Getting Involved</h1>
<p>
  We can use your help, whether it is programming, web development, documentation, providing feedback or getting the word out.
</p>

<h2>Mailing Lists</h2>
<p>
  The first thing you need to do is join the jsword-devel <a href="maillists.html">mailing list</a>.
  Everything that we do is openly discussed here.
</p>

<h2>Get a Development Environment</h2>
<p>
  At a minimum you will need Subversion (aka SVN) and a programmer's text editor. But to make things nicer,
  we recommend getting a SVN client and also a programmer's IDE. While there are many to choose from and they
  differ among OSes and you are welcomed to use whatever you wish, we use Eclipse as our IDE and with subclipse,
  an Eclipse plugin, as our SVN client. We can provide help if you use Eclipse, but if you use something else
  we might not be able to help. You can get instructions on how to set up Eclipse <a href="Eclipse.html">here</a>.
</p>

<h2>Get the Source Code</h2>
<p>
  We use Subversion for our source code control. Unless you have used SVN before, you may be surprised how
  it works. The <a href="http://svnbook.red-bean.com/">Subversion Book</a> makes good bedtime reading and
  provides the best explanation of how it works. In a nutshell, you "checkout" the code, which merely
  gets you a local copy of the code. You don't need any password to do this and you can use your web
  browser to browse the repository. For detailed instructions see our pages on <a href="svn.html">svn</a>
  and <a href="Eclipse.html">Eclipse</a>.
</p>  

<h2>Understanding the Code</h2>
<p>
  Before you can effectively make changes to the code, you need to understand it. Below outlines where you
  can get this information.
</p>

<h3>Source Documentation</h3> 
<p>
  The high level design comes in the form of an <a href="cobertura/org.crosswire.jsword.examples.APIExamples.html">API
  Primer</a> which describes how to go about reading and formatting data from JSword, using Bibles, Commentaries and Dictionaries
  (it comes with some decent <a href="javadoc/org/crosswire/jsword/examples/APIExamples.html">JavaDoc</a> too). There is also a <a href="design.html">design
  statement</a> that explains some of the top level design choices. It explains how the Book and Bible interfaces are arranged
  and justifies the design decisions.
</p>

<p>
  There is also the obligatory <a href="javadoc">JavaDoc</a> tree. Most of the source is fairly well documented,
  so the JavaDoc ought actually to be useful! There is also a web version of the <a href="cobertura">Java Source</a> converted
  to the web by <a href="http://cobertura.sourceforge.net">Cobertura</a>, with test coverage information.
</p>

<p>
  We use OSIS 2.1 as a standard for XML format Bible data. From the <a href="http://www.bibletechnologies.net">OSIS
  website</a>: The Open Scriptural Information Standard (OSIS) is an XML based markup of the Bible, commentaries and related
  texts that will facilitate interoperability across natural language boundaries and computer hardware and software for
  publication, linking, reference and accessibility.
</p>

<h2>Making Changes to Code</h2>
<p>
  The <a href="writingcode.html">introduction</a> document describes the aims of the project, and has 
  some comments on contributing code.
</p>

<h2>Test Results</h2> 
<p>
  We are run unit tests automatically on a nightly basis. The unit tests are run with the help of <a href="http://www.junit.org">JUnit</a> and
  we also get code coverage analysis performed by <a href="http://cobertura.sourceforge.net">Cobertura</a>. So you can easily see
  the latest <a href="junit">test results</a>, or some <a href="cobertura">coverage analysis</a> that
  shows how effective the tests are.
</p>

<h2>Quality Checks</h2>
<p>
  The nightly builds also run some freely available code quality checkers. The tools we use are:
  <a href="http://checkstyle.sourceforge.net">CheckStyle</a>,
  <a href="http://pmd.sourceforge.net">PMD and CPD</a>,
  <a href="http://findbugs.sourceforge.net">FindBugs</a>,
  <a href="http://www.clarkware.com/software/JDepend.html">JDepend</a> and
  <a href="http://www.kclee.de/clemens/java/javancss">NCSS</a>.
  These reports check many details of the source including that coding standards are being followed, that we are avoiding
  common traps and that we are not falling fowl of more obscure bugs.
</p>

<ul>
  <li><a href="checkstyle">Coding Standards report</a> generated by <a href="http://checkstyle.sourceforge.net">CheckStyle</a>.</li>
  <li><a href="http://pmd.sourceforge.net">PMD</a> reports <a href="pmd">common bugs</a> and <a href="cpd">needlessly copied code</a>.</li>
  <li><a href="findbugs">Bug report analysis</a> courtesy of <a href="http://findbugs.sourceforge.net">FindBugs</a>.</li>
  <li><a href="jdepend/jdepend-report.html">Dependency analysis</a> generated by <a href="http://www.clarkware.com/software/JDepend.html">JDepend</a>.</li>
  <li><a href="javancss">Non-comment source code</a> report from <a href="http://www.kclee.de/clemens/java/javancss">NCSS</a>.</li>
</ul>

<p>
  In addition the latest <a href="buildlog.txt">build log</a> will tell you how last nights build went.
</p>

</body>
</html>
